using GrapeCity.CalcEngine;
using GrapeCity.Spreadsheet.Localization;

namespace IIntelliSenseFuncDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ribbonBar1.GenerateDefaultItems();
            ribbonBar1.Attach(fpSpread1);
            fpSpread1.AddCustomFunction(new MhCompound());
            fpSpread1.AddCustomFunction(new MhLevel());
        }
    }

    public class MhLevel : GrapeCity.CalcEngine.Function
    {
        public MhLevel() : base("MHLevel", 1, 2, FunctionAttributes.SingleCell | FunctionAttributes.Number)
        {
        }
    }

    public class MhCompound : GrapeCity.CalcEngine.Function, IIntelliSenseFunction
    {
        public int Overloads { get => 1; }
        public MhCompound() : base("MHCompound", 1, 2, FunctionAttributes.SingleCell | FunctionAttributes.Number)
        {
        }

        public int GetArgumentCount(int argsCount, int overload, out bool limited)
        {
            limited = false;
            return -1;
        }

        public string GetArgumentDescription(LanguagePackage languagePackage, int index)
        {
            return string.Empty;
        }

        public string GetArgumentName(LanguagePackage languagePackage, int index, int argsCount, int overload = 0)
        {
            return string.Empty;
        }

        public object[] GetArgumentOptions(LanguagePackage languagePackage, int index)
        {
            return null;
        }

        public GrapeCity.CalcEngine.ValueType GetArgumentType(Function function, int index, int argCount, int overload = 0)
        {
            return GrapeCity.CalcEngine.ValueType.Empty;
        }

        public string GetDescription(LanguagePackage languagePackage)
        {
            return "text string";
        }

        public string GetDescription2(LanguagePackage languagePackage)
        {
            return "text string 2";
        }

        public bool GetGroupedArguments(int index, out int lowerIndex, out int upperIndex)
        {

            lowerIndex = 0;
            upperIndex = 0;
            return false;
        }
    }
}
